static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xA5, 0x26, 0x18, 0x6F, 0x4A, 0x21, 0x48, 0x78, 0x4A, 0xB1,
        0xA5, 0x1B, 0xE7, 0x04, 0xCD, 0x35, 0x58, 0x3E, 0xFF, 0xB1,
        0x08, 0xA4, 0x2A, 0x38, 0x6B, 0x35, 0x2C, 0xAA, 0xDB, 0xEC,
        0x9C, 0x19, 0x5D, 0x8A, 0x23, 0xC5, 0x7B, 0x99, 0x59, 0x5F,
        0xD0, 0xFC, 0x83, 0x9A, 0xC6, 0x36, 0xFA, 0x63, 0xA7, 0x8A,
        0xFA, 0x94, 0xC9, 0xCF, 0x76, 0x07, 0x84, 0x3F, 0xA7, 0x82,
        0x71, 0x4C, 0xA0, 0x93
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
